Sometimes you don't want the values of cells in a sheet to be edited. If so, you can use the isProtected option to set and get whether the sheet is protected.
If you want to protect the worksheet with a password, you can use protect, unprotect and hasPassword API.
When a sheet is protected, you can use protectionOptions to limit user actions by providing an object with the following properties:
allowSelectLockedCells: Boolean that represents whether the user can select locked cells.
allowSelectUnlockedCells: Boolean that represents whether the user can select unlocked cells.
allowSort: Boolean that represents whether the user can sort ranges.
allowFilter: Boolean that represents whether the user can filter ranges.
allowEditObjects: Boolean that represents whether the user can edit floating objects.
allowResizeRows: Boolean that represents whether the user can resize rows.
allowResizeColumns: Boolean that represents whether the user can resize columns.
allowDragInsertRows: Boolean that represents whether the user can drag insert rows.
allowDragInsertColumns: Boolean that represents whether the user can drag insert columns.
allowInsertRows: Boolean that represents whether the user can insert rows.
allowInsertColumns: Boolean that represents whether the user can insert columns.
allowDeleteRows: Boolean that represents whether the user can delete rows.
allowDeleteColumns: Boolean that represents whether the user can delete columns.
allowOutlineRows: Boolean that represents whether the user can expand or collapse row outline.
allowOutlineColumns: Boolean that represents whether the user can expand or collapse column outline.
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), {
sheetCount: 1
});
initSpread(spread);
};
const passwordWrongTip = 'Password is not correct!';
const alreadyProtect = 'The worksheet is already protected!';
const unprotectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC';
const protectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC';
function initSpread(spread) {
var sheet = spread.getActiveSheet();
spread.suspendPaint();
var salesData = [
['Salesperson', 'Region'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East']
];
sheet.setArray(0, 0, salesData);
sheet.setColumnWidth(0, 120);
sheet.setColumnWidth(1, 120);
//unlocked cells
var style = new GC.Spread.Sheets.Style();
style.locked = false;
style.backColor = '#C3C3C3';
sheet.setStyle(-1, 8, style);
sheet.setStyle(-1, 9, style);
sheet.setStyle(15, -1, style);
sheet.setStyle(16, -1, style);
sheet.setStyle(8, 2, style);
//locked cells
var style2 = new GC.Spread.Sheets.Style();
style2.locked = true;
style2.backColor = '#F4F8EB';
sheet.setStyle(13, -1, style2);
sheet.setStyle(18, 8, style2);
sheet.setStyle(0, 0, style2)
sheet.setStyle(0, 1, style2);
var filter = new GC.Spread.Sheets.Filter.HideRowFilter(new GC.Spread.Sheets.Range(1, 0, 100, 2));
sheet.rowFilter(filter);
sheet.comments.add(5, 4, 'locked comment');
sheet.comments.add(22, 4, 'unlocked comment');
sheet.comments.get(5, 4).locked(true).displayMode(1);
sheet.comments.get(22, 4).locked(false).displayMode(1).lockText(false);
var _commandManager = spread.commandManager();
_commandManager.execute({
cmd: "outlineColumn",
sheetName: sheet.name(),
index: 11,
count: 3
});
_commandManager.execute({
cmd: "outlineRow",
sheetName: sheet.name(),
index: 18,
count: 3
});
spread.resumePaint();
var option = {
allowSelectLockedCells:true,
allowSelectUnlockedCells:true,
allowFilter: true,
allowSort: false,
allowResizeRows: true,
allowResizeColumns: false,
allowEditObjects: false,
allowDragInsertRows: false,
allowDragInsertColumns: false,
allowInsertRows: false,
allowInsertColumns: false,
allowDeleteRows: false,
allowDeleteColumns: false,
allowOutlineColumns: false,
allowOutlineRows: false
};
sheet.options.protectionOptions = option;
sheet.options.isProtected = true;
option = sheet.options.protectionOptions;
_getElementById('chkSelectLockedCells').checked = option.allowSelectLockedCells;
_getElementById('chkSelectUnlockedCells').checked = option.allowSelectUnlockedCells;
_getElementById('chkAllowSort').checked = option.allowSort;
_getElementById('chkAllowFilter').checked = option.allowFilter;
_getElementById('chkAllowResizeRows').checked = option.allowResizeRows;
_getElementById('chkAllowResizeColumns').checked = option.allowResizeColumns;
_getElementById('chkAllowEditObjects').checked = option.allowEditObjects;
_getElementById('chkAllowDragInsertRows').checked = option.allowDragInsertRows;
_getElementById('chkAllowDragInsertColumns').checked = option.allowDragInsertColumns;
_getElementById('chkAllowInsertRows').checked = option.allowInsertRows;
_getElementById('chkAllowInsertColumns').checked = option.allowInsertColumns;
_getElementById('chkAllowDeleteRows').checked = option.allowDeleteRows;
_getElementById('chkAllowDeleteColumns').checked = option.allowDeleteColumns;
_getElementById('chkallowOutlineColumns').checked = option.allowOutlineColumns;
_getElementById('chkallowOutlineRows').checked = option.allowOutlineRows;
const protectStatus = _getElementById('protectStatus');
const passwordInput = _getElementById('protectPassword')
protectStatus.src = sheet.options.isProtected ? protectImg : unprotectImg;
let protectBtn = _getElementById('protectBtn'), unprotectBtn = _getElementById('unprotectBtn');
protectBtn.disabled = true;
protectBtn.addEventListener('click', function () {
sheet = spread.getActiveSheet();
if (sheet.options.isProtected) {
alert(alreadyProtect);
return ;
}
const password = passwordInput.value;
passwordInput.value = '';
sheet.protect(password);
protectStatus.src = protectImg;
protectBtn.disabled = true;
unprotectBtn.disabled = false;
});
unprotectBtn.addEventListener('click', function () {
const password = passwordInput.value;
sheet = spread.getActiveSheet();
if (sheet.hasPassword()) {
let success = sheet.unprotect(password);
if (!success) {
alert(passwordWrongTip);
return ;
}
} else {
sheet.unprotect();
}
passwordInput.value = '';
protectStatus.src = unprotectImg;
protectBtn.disabled = false;
unprotectBtn.disabled = true;
})
_getElementById('setProtectionOptions').addEventListener('click', function() {
var option = {
allowSelectLockedCells: _getElementById('chkSelectLockedCells').checked,
allowSelectUnlockedCells: _getElementById('chkSelectUnlockedCells').checked,
allowSort: _getElementById('chkAllowSort').checked,
allowFilter: _getElementById('chkAllowFilter').checked,
allowResizeRows: _getElementById('chkAllowResizeRows').checked,
allowResizeColumns: _getElementById('chkAllowResizeColumns').checked,
allowEditObjects: _getElementById('chkAllowEditObjects').checked,
allowDragInsertRows: _getElementById('chkAllowDragInsertRows').checked,
allowDragInsertColumns: _getElementById('chkAllowDragInsertColumns').checked,
allowInsertRows: _getElementById('chkAllowInsertRows').checked,
allowInsertColumns: _getElementById('chkAllowInsertColumns').checked,
allowDeleteRows: _getElementById('chkAllowDeleteRows').checked,
allowDeleteColumns: _getElementById('chkAllowDeleteColumns').checked,
allowOutlineColumns: _getElementById('chkallowOutlineColumns').checked,
allowOutlineRows: _getElementById('chkallowOutlineRows').checked
};
var sheet = spread.getActiveSheet();
sheet.options.protectionOptions = option;
});
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<br/>
<div class="option-row" style="height: 25px">
<img id = "protectStatus" style="height: 25px"/>
</div>
<div class="option-row">
<label for="protectPassword">Password (optional)</label>
<input id="protectPassword" type="password"/>
<input type="button" value="Protect" id="protectBtn" style="width:100px;"/>
<input type="button" value="Unprotect" id="unprotectBtn" style="width:100px;"/>
</div>
<br />
<div class="option-row">
<label >Use following protection options to limit what the user can do in regards to editing the sheet.</label>
</div>
<div>
<div class="option-row">
<input id="chkSelectLockedCells" type="checkbox" checked="checked" />
<label for="chkSelectLockedCells" class="sizedLabel">Select locked cells</label>
</div>
<div class="option-row">
<input id="chkSelectUnlockedCells" type="checkbox" checked="checked" />
<label for="chkSelectUnlockedCells" class="sizedLabel">Select unlocked cells</label>
</div>
<div class="option-row">
<input id="chkAllowSort" type="checkbox" />
<label for="chkAllowSort" class="sizedLabel">Sort</label>
</div>
<div class="option-row">
<input id="chkAllowFilter" type="checkbox" />
<label for="chkAllowFilter" class="sizedLabel">Filter</label>
</div>
<div class="option-row">
<input id="chkAllowResizeRows" type="checkbox" />
<label for="chkAllowResizeRows" class="sizedLabel">Resize rows</label>
</div>
<div class="option-row">
<input id="chkAllowResizeColumns" type="checkbox" />
<label for="chkAllowResizeColumns" class="sizedLabel">Resize columns</label>
</div>
<div class="option-row">
<input id="chkAllowEditObjects" type="checkbox" />
<label for="chkAllowEditObjects" class="sizedLabel">Edit objects</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertRows" type="checkbox" />
<label for="chkAllowDragInsertRows" class="sizedLabel">Drag insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertColumns" type="checkbox" />
<label for="chkAllowDragInsertColumns" class="sizedLabel">Drag insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowInsertRows" type="checkbox" />
<label for="chkAllowInsertRows" class="sizedLabel">Insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowInsertColumns" type="checkbox" />
<label for="chkAllowInsertColumns" class="sizedLabel">Insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteRows" type="checkbox" />
<label for="chkAllowDeleteRows" class="sizedLabel">Delete rows</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteColumns" type="checkbox" />
<label for="chkAllowDeleteColumns" class="sizedLabel">Delete columns</label>
</div>
<div class="option-row">
<input id="chkallowOutlineRows" type="checkbox" />
<label for="chkallowOutlineRows" class="sizedLabel">Operate row outline</label>
</div>
<div class="option-row">
<input id="chkallowOutlineColumns" type="checkbox" />
<label for="chkallowOutlineColumns" class="sizedLabel">Operate column outline</label>
</div>
<div class="option-row">
<input type="button" value="Set" id="setProtectionOptions" style="width:100px;"/>
</div>
<div class="option-row">
<label>Select the protection options and then click Set</label>
</div>
</div>
</div>
</div>
</body>
</html>
.sizedLabel {
display: inline-block;
width: 180px;
}
.colorLabel {
background-color: #F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

Sometimes you don't want the values of cells in a sheet to be edited. If so, you can use the isProtected option to set and get whether the sheet is protected.
If you want to protect the worksheet with a password, you can use protect, unprotect and hasPassword API.
When a sheet is protected, you can use protectionOptions to limit user actions by providing an object with the following properties:
allowSelectLockedCells: Boolean that represents whether the user can select locked cells.
allowSelectUnlockedCells: Boolean that represents whether the user can select unlocked cells.
allowSort: Boolean that represents whether the user can sort ranges.
allowFilter: Boolean that represents whether the user can filter ranges.
allowEditObjects: Boolean that represents whether the user can edit floating objects.
allowResizeRows: Boolean that represents whether the user can resize rows.
allowResizeColumns: Boolean that represents whether the user can resize columns.
allowDragInsertRows: Boolean that represents whether the user can drag insert rows.
allowDragInsertColumns: Boolean that represents whether the user can drag insert columns.
allowInsertRows: Boolean that represents whether the user can insert rows.
allowInsertColumns: Boolean that represents whether the user can insert columns.
allowDeleteRows: Boolean that represents whether the user can delete rows.
allowDeleteColumns: Boolean that represents whether the user can delete columns.
allowOutlineRows: Boolean that represents whether the user can expand or collapse row outline.
allowOutlineColumns: Boolean that represents whether the user can expand or collapse column outline.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { FormsModule } from '@angular/forms';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const passwordWrongTip = 'Password is not correct!';
const alreadyProtect = 'The worksheet is already protected!';
const unprotectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC';
const protectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
protectSheet = true;
selectLockedCells = true;
selectUnlockedCells = true;
sort = false;
filter = true;
resizeRows = true;
resizeColums = false;
editObject = false;
dragInsertRows = false;
dragInsertColums = false;
insrtRows = false;
insertColumns = false;
deleteRows = false;
deleteColumn = false;
operateColumnOutline = false;
operateRowOutline = false;
password: '';
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
protectStatus: string = protectImg;
applySetting() {
let option = {
allowSelectLockedCells: this.selectLockedCells,
allowSelectUnlockedCells: this.selectUnlockedCells,
allowSort: this.sort,
allowFilter: this.filter,
allowResizeRows: this.resizeRows,
allowResizeColumns: this.resizeColums,
allowEditObjects: this.editObject,
allowDragInsertRows: this.dragInsertRows,
allowDragInsertColumns: this.dragInsertColums,
allowInsertRows: this.insrtRows,
allowInsertColumns: this.insertColumns,
allowDeleteRows: this.deleteRows,
allowDeleteColumns: this.deleteColumn,
allowOutlineColumns: this.operateColumnOutline,
allowOutlineRows: this.operateRowOutline,
};
let sheet = this.spread.getActiveSheet();
sheet.options.protectionOptions = option;
}
setselectLockedCells(value: any) {
this.selectLockedCells = value.target.checked;
}
setselectUnlockedCells(value: any) {
this.selectUnlockedCells = value.target.checked;
}
setSort(value: any) {
this.sort = value.target.checked;
}
setfilter(value: any) {
this.filter = value.target.checked;
}
setresizeRows(value: any) {
this.resizeRows = value.target.checked;
}
setresizeColums(value: any) {
this.resizeColums = value.target.checked;
}
seteditObject(value: any) {
this.editObject = value.target.checked;
}
setdragInsertRows(value: any) {
this.dragInsertRows = value.target.checked;
}
setdragInsertColums(value: any) {
this.dragInsertColums = value.target.checked;
}
setinsrtRows(value: any) {
this.insrtRows = value.target.checked;
}
setinsertColumns(value: any) {
this.insertColumns = value.target.checked;
}
setdeleteRows(value: any) {
this.deleteRows = value.target.checked;
}
setdeleteColumn(value: any) {
this.deleteColumn = value.target.checked;
}
setOperateColumnOutline(value: any) {
this.operateColumnOutline = value.target.checked;
}
setOperateRowOutline(value: any) {
this.operateRowOutline = value.target.checked;
}
setProtectSheet(value: any) {
let sheet = this.spread.getActiveSheet();
if (sheet.options.isProtected) {
alert(alreadyProtect);
return ;
}
const password = this.password;
this.password = '';
sheet.protect(password);
this.protectSheet = sheet.options.isProtected;
this.protectStatus = protectImg;
}
setUnprotectSheet() {
const password = this.password;
let sheet = this.spread.getActiveSheet();
if (sheet.hasPassword()) {
let success = sheet.unprotect(password);
if (!success) {
alert(passwordWrongTip);
return ;
}
} else {
sheet.unprotect();
}
this.password = '';
this.protectSheet = sheet.options.isProtected;
this.protectStatus = unprotectImg;
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
let salesData = [
['Salesperson', 'Region'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East']
];
sheet.setArray(0, 0, salesData);
sheet.setColumnWidth(0, 120);
sheet.setColumnWidth(1, 120);
//unlocked cells
let style = new GC.Spread.Sheets.Style();
style.locked = false;
style.backColor = '#C3C3C3';
sheet.setStyle(-1, 8, style);
sheet.setStyle(-1, 9, style);
sheet.setStyle(15, -1, style);
sheet.setStyle(16, -1, style);
sheet.setStyle(8, 2, style);
//locked cells
let style2 = new GC.Spread.Sheets.Style();
style2.locked = true;
style2.backColor = '#F4F8EB';
sheet.setStyle(13, -1, style2);
sheet.setStyle(18, 8, style2);
sheet.setStyle(0, 0, style2)
sheet.setStyle(0, 1, style2);
let filter = new GC.Spread.Sheets.Filter.HideRowFilter(new GC.Spread.Sheets.Range(1, 0, 100, 2));
sheet.rowFilter(filter);
sheet.comments.add(5, 4, 'locked comment');
sheet.comments.add(22, 4, 'unlocked comment');
sheet.comments.get(5, 4).locked(true).displayMode(1);
sheet.comments.get(22, 4).locked(false).displayMode(1).lockText(false);
var _commandManager = spread.commandManager();
_commandManager.execute({
cmd: "outlineColumn",
sheetName: sheet.name(),
index: 11,
count: 3
});
_commandManager.execute({
cmd: "outlineRow",
sheetName: sheet.name(),
index: 18,
count: 3
});
spread.resumePaint();
let option = {
allowSelectLockedCells: true,
allowSelectUnlockedCells: true,
allowFilter: true,
allowSort: false,
allowResizeRows: true,
allowResizeColumns: false,
allowEditObjects: false,
allowDragInsertRows: false,
allowDragInsertColumns: false,
allowInsertRows: false,
allowInsertColumns: false,
allowDeleteRows: false,
allowDeleteColumns: false
};
sheet.options.protectionOptions = option;
sheet.options.isProtected = true;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<br />
<div class="option-row" style="height: 25px">
<img id = "protectStatus" style="height: 25px" [src]="protectStatus"/>
</div>
<div class="option-row">
<label for="protectPassword">Password (optional)</label>
<input id="protectPassword" type="password" [(ngModel)]="password"/>
<input type="button" value="Protect" id="protectBtn" (click)="setProtectSheet($event)" style="width:100px;" [disabled]="protectSheet"/>
<input type="button" value="Unprotect" id="unprotectBtn" (click)="setUnprotectSheet($event)" style="width:100px; margin-left: 5px;" [disabled]="!protectSheet"/>
</div>
<div>
<div class="option-row">
<input id="chkSelectLockedCells" checked (change)="setselectLockedCells($event)" type="checkbox" />
<label for="chkSelectLockedCells" class="sizedLabel">Select locked cells</label>
</div>
<div class="option-row">
<input id="chkSelectUnlockedCells" checked (change)="setselectUnlockedCells($event)" type="checkbox" />
<label for="chkSelectUnlockedCells" class="sizedLabel">Select unlocked cells</label>
</div>
<div class="option-row">
<input id="chkAllowSort" type="checkbox" (change)="setSort($event)" />
<label for="chkAllowSort" class="sizedLabel">Sort</label>
</div>
<div class="option-row">
<input id="chkAllowFilter" type="checkbox" checked (change)="setfilter($event)" />
<label for="chkAllowFilter" class="sizedLabel">Filter</label>
</div>
<div class="option-row">
<input id="chkAllowResizeRows" type="checkbox" checked (change)="setresizeRows($event)" />
<label for="chkAllowResizeRows" class="sizedLabel">Resize rows</label>
</div>
<div class="option-row">
<input id="chkAllowResizeColumns" type="checkbox" (change)="setresizeColums($event)"/>
<label for="chkAllowResizeColumns" class="sizedLabel">Resize columns</label>
</div>
<div class="option-row">
<input id="chkAllowEditObjects" type="checkbox" (change)="seteditObject($event)" />
<label for="chkAllowEditObjects" class="sizedLabel">Edit objects</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertRows" type="checkbox" (change)="setdragInsertRows($event)" />
<label for="chkAllowDragInsertRows" class="sizedLabel">Drag insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertColumns" type="checkbox" (change)="setdragInsertColums($event)" />
<label for="chkAllowDragInsertColumns" class="sizedLabel">Drag insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowInsertRows" type="checkbox" (change)="setinsrtRows($event)" />
<label for="chkAllowInsertRows" class="sizedLabel">Insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowInsertColumns" type="checkbox" (change)="setinsertColumns($event)" />
<label for="chkAllowInsertColumns" class="sizedLabel">Insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteRows" type="checkbox" (change)="setdeleteRows($event)" />
<label for="chkAllowDeleteRows" class="sizedLabel">Delete rows</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteColumns" type="checkbox" (change)="setdeleteColumn($event)"/>
<label for="chkAllowDeleteColumns" class="sizedLabel">Delete columns</label>
</div>
<div class="option-row">
<input id="chkallowOutlineRows" type="checkbox" (change)="setOperateRowOutline($event)"/>
<label for="chkallowOutlineRows" class="sizedLabel">Operate row outline</label>
</div>
<div class="option-row">
<input id="chkallowOutlineColumns" type="checkbox" (change)="setOperateColumnOutline($event)"/>
<label for="chkallowOutlineColumns" class="sizedLabel">Operate column outline</label>
</div>
<div class="option-row">
<input type="button" value="Set" id="setProtectionOptions" (click)="applySetting($event)" style="width: 100px " />
</div>
<div class="option-row">
<label>Select the protection options and then click Set</label>
</div>
</div>
</div>
</div>
.sizedLabel {
display: inline-block;
width: 180px;
}
.colorLabel {
background-color: #F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Sometimes you don't want the values of cells in a sheet to be edited. If so, you can use the isProtected option to set and get whether the sheet is protected.
If you want to protect the worksheet with a password, you can use protect, unprotect and hasPassword API.
When a sheet is protected, you can use protectionOptions to limit user actions by providing an object with the following properties:
allowSelectLockedCells: Boolean that represents whether the user can select locked cells.
allowSelectUnlockedCells: Boolean that represents whether the user can select unlocked cells.
allowSort: Boolean that represents whether the user can sort ranges.
allowFilter: Boolean that represents whether the user can filter ranges.
allowEditObjects: Boolean that represents whether the user can edit floating objects.
allowResizeRows: Boolean that represents whether the user can resize rows.
allowResizeColumns: Boolean that represents whether the user can resize columns.
allowDragInsertRows: Boolean that represents whether the user can drag insert rows.
allowDragInsertColumns: Boolean that represents whether the user can drag insert columns.
allowInsertRows: Boolean that represents whether the user can insert rows.
allowInsertColumns: Boolean that represents whether the user can insert columns.
allowDeleteRows: Boolean that represents whether the user can delete rows.
allowDeleteColumns: Boolean that represents whether the user can delete columns.
allowOutlineRows: Boolean that represents whether the user can expand or collapse row outline.
allowOutlineColumns: Boolean that represents whether the user can expand or collapse column outline.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const passwordWrongTip = 'Password is not correct!';
const alreadyProtect = 'The worksheet is already protected!';
const unprotectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC';
const protectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC';
const useState = React.useState;
let spread = null;
export function AppFunc() {
const [protectSheet, setProtectSheet] = useState(true);
const [selectLockedCells, setselectLockedCells] = useState(true);
const [selectUnlockedCells, setselectUnlockedCells] = useState(true);
const [sort, setSort] = useState(false);
const [filter, setfilter] = useState(true);
const [resizeRows, setresizeRows] = useState(true);
const [resizeColums, setresizeColums] = useState(false);
const [editObject, seteditObject] = useState(false);
const [dragInsertRows, setdragInsertRows] = useState(false);
const [dragInsertColums, setdragInsertColums] = useState(false);
const [insrtRows, setinsrtRows] = useState(false);
const [insertColumns, setinsertColumns] = useState(false);
const [deleteRows, setdeleteRows] = useState(false);
const [deleteColumn, setdeleteColumn] = useState(false);
const [operateColumnOutline, setoperateColumnOutline] = useState(false);
const [operateRowOutline, setoperateRowOutline] = useState(false);
const [password, setPassword] = useState('');
const applySetting = () => {
let option = {
allowSelectLockedCells: selectLockedCells,
allowSelectUnlockedCells: selectUnlockedCells,
allowSort: sort,
allowFilter: filter,
allowResizeRows: resizeRows,
allowResizeColumns: resizeColums,
allowEditObjects: editObject,
allowDragInsertRows: dragInsertRows,
allowDragInsertColumns: dragInsertColums,
allowInsertRows: insrtRows,
allowInsertColumns: insertColumns,
allowDeleteRows: deleteRows,
allowDeleteColumns: deleteColumn,
allowOutlineColumns: operateColumnOutline,
allowOutlineRows: operateRowOutline
};
let sheet = spread.getActiveSheet();
sheet.options.protectionOptions = option;
}
const _setProtectSheet = () => {
let sheet = spread.getActiveSheet();
if (sheet.options.isProtected) {
alert(alreadyProtect);
return;
}
sheet.protect(password);
setProtectSheet(true);
setPassword('');
}
const setUnprotectSheet = () => {
let sheet = spread.getActiveSheet();
if (sheet.hasPassword()) {
let success = sheet.unprotect(password);
if (!success) {
alert(passwordWrongTip);
return;
}
} else {
sheet.unprotect();
}
setProtectSheet(false);
setPassword('');
}
const initSpread = (currSpread) => {
spread = currSpread;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
let salesData = [
['Salesperson', 'Region'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East']
];
sheet.setArray(0, 0, salesData);
sheet.setColumnWidth(0, 120);
sheet.setColumnWidth(1, 120);
//unlocked cells
let style = new GC.Spread.Sheets.Style();
style.locked = false;
style.backColor = '#C3C3C3';
sheet.setStyle(-1, 8, style);
sheet.setStyle(-1, 9, style);
sheet.setStyle(15, -1, style);
sheet.setStyle(16, -1, style);
sheet.setStyle(8, 2, style);
//locked cells
let style2 = new GC.Spread.Sheets.Style();
style2.locked = true;
style2.backColor = '#F4F8EB';
sheet.setStyle(13, -1, style2);
sheet.setStyle(18, 8, style2);
sheet.setStyle(0, 0, style2)
sheet.setStyle(0, 1, style2);
let filter = new GC.Spread.Sheets.Filter.HideRowFilter(new GC.Spread.Sheets.Range(1, 0, 100, 2));
sheet.rowFilter(filter);
sheet.comments.add(5, 4, 'locked comment');
sheet.comments.add(22, 4, 'unlocked comment');
sheet.comments.get(5, 4).locked(true).displayMode(1);
sheet.comments.get(22, 4).locked(false).displayMode(1).lockText(false);
var _commandManager = spread.commandManager();
_commandManager.execute({
cmd: "outlineColumn",
sheetName: sheet.name(),
index: 11,
count: 3
});
_commandManager.execute({
cmd: "outlineRow",
sheetName: sheet.name(),
index: 18,
count: 3
});
spread.resumePaint();
let option = {
allowSelectLockedCells: true,
allowSelectUnlockedCells: true,
allowFilter: true,
allowSort: false,
allowResizeRows: true,
allowResizeColumns: false,
allowEditObjects: false,
allowDragInsertRows: false,
allowDragInsertColumns: false,
allowInsertRows: false,
allowInsertColumns: false,
allowDeleteRows: false,
allowDeleteColumns: false
};
sheet.options.protectionOptions = option;
sheet.options.isProtected = true;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div class="options-container">
<br />
<div class="option-row" style={{ height: '25px' }}>
<img id="protectStatus" style={{ height: '25px' }} src={protectSheet ? protectImg : unprotectImg} />
</div>
<div class="option-row">
<label for="protectPassword">Password (optional)</label>
<input id="protectPassword" type="password" value={password} onChange={(e) => setPassword(e.target.value)} />
<input type="button" value="Protect" id="protectBtn" onClick={() => _setProtectSheet()} style={{ width: '100px' }} disabled={protectSheet} />
<input type="button" value="Unprotect" id="unprotectBtn" onClick={() => setUnprotectSheet()} style={{ width: '100px', marginLeft: '10px' }} disabled={!protectSheet} />
</div>
<br />
<div class="option-row">
<label >Use following protection options to limit what the user can do in regards to editing the sheet.</label>
</div>
<div>
<div class="option-row">
<input id="chkSelectLockedCells" onChange={(e) => setselectLockedCells(e.target.checked)} type="checkbox" checked={selectLockedCells} />
<label for="chkSelectLockedCells" class="sizedLabel">Select locked cells</label>
</div>
<div class="option-row">
<input id="chkSelectUnlockedCells" onChange={(e) => setselectUnlockedCells(e.target.checked)} type="checkbox" checked={selectUnlockedCells} />
<label for="chkSelectUnlockedCells" class="sizedLabel">Select unlocked cells</label>
</div>
<div class="option-row">
<input id="chkAllowSort" type="checkbox" onChange={(e) => setSort(e.target.checked)} checked={sort} />
<label for="chkAllowSort" class="sizedLabel">Sort</label>
</div>
<div class="option-row">
<input id="chkAllowFilter" type="checkbox" onChange={(e) => setfilter(e.target.checked)} checked={filter} />
<label for="chkAllowFilter" class="sizedLabel">Filter</label>
</div>
<div class="option-row">
<input id="chkAllowResizeRows" type="checkbox" onChange={(e) => setresizeRows(e.target.checked)} checked={resizeRows} />
<label for="chkAllowResizeRows" class="sizedLabel">Resize rows</label>
</div>
<div class="option-row">
<input id="chkAllowResizeColumns" type="checkbox" onChange={(e) => setresizeColums(e.target.checked)} checked={resizeColums} />
<label for="chkAllowResizeColumns" class="sizedLabel">Resize columns</label>
</div>
<div class="option-row">
<input id="chkAllowEditObjects" type="checkbox" onChange={(e) => seteditObject(e.target.checked)} checked={editObject} />
<label for="chkAllowEditObjects" class="sizedLabel">Edit objects</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertRows" type="checkbox" onChange={(e) => setdragInsertRows(e.target.checked)} checked={dragInsertRows} />
<label for="chkAllowDragInsertRows" class="sizedLabel">Drag insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertColumns" type="checkbox" onChange={(e) => setdragInsertColums(e.target.checked)} checked={dragInsertColums} />
<label for="chkAllowDragInsertColumns" class="sizedLabel">Drag insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowInsertRows" type="checkbox" onChange={(e) => setinsrtRows(e.target.checked)} checked={insrtRows} />
<label for="chkAllowInsertRows" class="sizedLabel">Insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowInsertColumns" type="checkbox" onChange={(e) => setinsertColumns(e.target.checked)} checked={insertColumns} />
<label for="chkAllowInsertColumns" class="sizedLabel">Insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteRows" type="checkbox" onChange={(e) => setdeleteRows(e.target.checked)} checked={deleteRows} />
<label for="chkAllowDeleteRows" class="sizedLabel">Delete rows</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteColumns" type="checkbox" onChange={(e) => setdeleteColumn(e.target.checked)} checked={deleteColumn} />
<label for="chkAllowDeleteColumns" class="sizedLabel">Delete columns</label>
</div>
<div class="option-row">
<input id="chkallowOutlineRows" type="checkbox" onChange={(e) => setoperateRowOutline(e.target.checked)} checked={operateRowOutline} />
<label for="chkallowOutlineRows" class="sizedLabel">Operate row outline</label>
</div>
<div class="option-row">
<input id="chkallowOutlineColumns" type="checkbox" onChange={(e) => setoperateColumnOutline(e.target.checked)} checked={operateColumnOutline} />
<label for="chkallowOutlineColumns" class="sizedLabel">Operate column outline</label>
</div>
<div class="option-row">
<input type="button" value="Set" id="setProtectionOptions" onClick={() => applySetting()} style={{ width: '100px' }} />
</div>
<div class="option-row">
<label>Select the protection options and then click Set</label>
</div>
</div>
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const Component = React.Component;
const passwordWrongTip = 'Password is not correct!';
const alreadyProtect = 'The worksheet is already protected!';
const unprotectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC';
const protectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC';
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
protectSheet: true,
selectLockedCells: true,
selectUnlockedCells: true,
sort: false,
filter: true,
resizeRows: true,
resizeColums: false,
editObject: false,
dragInsertRows: false,
dragInsertColums: false,
insrtRows: false,
insertColumns: false,
deleteRows: false,
deleteColumn: false,
operateColumnOutline: false,
operateRowOutline: false,
password: ''
}
}
render() {
const { protectSheet, selectLockedCells, selectUnlockedCells, sort, filter, resizeRows, resizeColums, editObject, dragInsertRows, dragInsertColums,
insrtRows, insertColumns, deleteRows, deleteColumn, operateColumnOutline, operateRowOutline, password} = this.state;
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div class="options-container">
<br />
<div class="option-row" style={{height: '25px'}}>
<img id="protectStatus" style={{height: '25px'}} src={protectSheet ? protectImg : unprotectImg}/>
</div>
<div class="option-row">
<label for="protectPassword">Password (optional)</label>
<input id="protectPassword" type="password" value={password} onChange={(e)=>this.setState({password: e.target.value})}/>
<input type="button" value="Protect" id="protectBtn" onClick={()=>{this.setProtectSheet()}} style={{width:'100px'}} disabled={protectSheet}/>
<input type="button" value="Unprotect" id="unprotectBtn" onClick={()=>{this.setUnprotectSheet()}} style={{width:'100px', marginLeft: '10px'}} disabled={!protectSheet}/>
</div>
<br />
<div class="option-row">
<label >Use following protection options to limit what the user can do in regards to editing the sheet.</label>
</div>
<div>
<div class="option-row">
<input id="chkSelectLockedCells" onChange={(e) => { this.setselectLockedCells(e.target.checked) }} type="checkbox" checked={selectLockedCells} />
<label for="chkSelectLockedCells" class="sizedLabel">Select locked cells</label>
</div>
<div class="option-row">
<input id="chkSelectUnlockedCells" onChange={(e) => { this.setselectUnlockedCells(e.target.checked) }} type="checkbox" checked={selectUnlockedCells} />
<label for="chkSelectUnlockedCells" class="sizedLabel">Select unlocked cells</label>
</div>
<div class="option-row">
<input id="chkAllowSort" type="checkbox" onChange={(e) => { this.setSort(e.target.checked) }} checked={sort} />
<label for="chkAllowSort" class="sizedLabel">Sort</label>
</div>
<div class="option-row">
<input id="chkAllowFilter" type="checkbox" onChange={(e) => { this.setfilter(e.target.checked) }} checked={filter} />
<label for="chkAllowFilter" class="sizedLabel">Filter</label>
</div>
<div class="option-row">
<input id="chkAllowResizeRows" type="checkbox" onChange={(e) => { this.setresizeRows(e.target.checked) }} checked={resizeRows} />
<label for="chkAllowResizeRows" class="sizedLabel">Resize rows</label>
</div>
<div class="option-row">
<input id="chkAllowResizeColumns" type="checkbox" onChange={(e) => { this.setresizeColums(e.target.checked) }} checked={resizeColums} />
<label for="chkAllowResizeColumns" class="sizedLabel">Resize columns</label>
</div>
<div class="option-row">
<input id="chkAllowEditObjects" type="checkbox" onChange={(e) => { this.seteditObject(e.target.checked) }} checked={editObject} />
<label for="chkAllowEditObjects" class="sizedLabel">Edit objects</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertRows" type="checkbox" onChange={(e) => { this.setdragInsertRows(e.target.checked) }} checked={dragInsertRows} />
<label for="chkAllowDragInsertRows" class="sizedLabel">Drag insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertColumns" type="checkbox" onChange={(e) => { this.setdragInsertColums(e.target.checked) }} checked={dragInsertColums} />
<label for="chkAllowDragInsertColumns" class="sizedLabel">Drag insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowInsertRows" type="checkbox" onChange={(e) => { this.setinsrtRows(e.target.checked) }} checked={insrtRows} />
<label for="chkAllowInsertRows" class="sizedLabel">Insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowInsertColumns" type="checkbox" onChange={(e) => { this.setinsertColumns(e.target.checked) }} checked={insertColumns} />
<label for="chkAllowInsertColumns" class="sizedLabel">Insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteRows" type="checkbox" onChange={(e) => { this.setdeleteRows(e.target.checked) }} checked={deleteRows} />
<label for="chkAllowDeleteRows" class="sizedLabel">Delete rows</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteColumns" type="checkbox" onChange={(e) => { this.setdeleteColumn(e.target.checked) }} checked={deleteColumn} />
<label for="chkAllowDeleteColumns" class="sizedLabel">Delete columns</label>
</div>
<div class="option-row">
<input id="chkallowOutlineRows" type="checkbox" onChange={(e) => { this.setoperateRowOutline(e.target.checked) }} checked={operateRowOutline} />
<label for="chkallowOutlineRows" class="sizedLabel">Operate row outline</label>
</div>
<div class="option-row">
<input id="chkallowOutlineColumns" type="checkbox" onChange={(e) => { this.setoperateColumnOutline(e.target.checked) }} checked={operateColumnOutline} />
<label for="chkallowOutlineColumns" class="sizedLabel">Operate column outline</label>
</div>
<div class="option-row">
<input type="button" value="Set" id="setProtectionOptions" onClick={() => { this.applySetting() }} style={{ width: '100px' }} />
</div>
<div class="option-row">
<label>Select the protection options and then click Set</label>
</div>
</div>
</div>
</div>
)
}
applySetting() {
let option = {
allowSelectLockedCells: this.state.selectLockedCells,
allowSelectUnlockedCells: this.state.selectUnlockedCells,
allowSort: this.state.sort,
allowFilter: this.state.filter,
allowResizeRows: this.state.resizeRows,
allowResizeColumns: this.state.resizeColums,
allowEditObjects: this.state.editObject,
allowDragInsertRows: this.state.dragInsertRows,
allowDragInsertColumns: this.state.dragInsertColums,
allowInsertRows: this.state.insrtRows,
allowInsertColumns: this.state.insertColumns,
allowDeleteRows: this.state.deleteRows,
allowDeleteColumns: this.state.deleteColumn,
allowOutlineColumns: this.state.operateColumnOutline,
allowOutlineRows: this.state.operateRowOutline
};
let sheet = this.spread.getActiveSheet();
sheet.options.protectionOptions = option;
}
setselectLockedCells(value) {
this.setState({
selectLockedCells: value
})
}
setselectUnlockedCells(value) {
this.setState({
selectUnlockedCells: value
})
}
setSort(value) {
this.setState({
sort: value
})
}
setfilter(value) {
this.setState({
filter: value
})
}
setresizeRows(value) {
this.setState({
resizeRows: value
})
}
setresizeColums(value) {
this.setState({
resizeColums: value
})
}
seteditObject(value) {
this.setState({
editObject: value
})
}
setdragInsertRows(value) {
this.setState({
dragInsertRows: value
})
}
setdragInsertColums(value) {
this.setState({
dragInsertColums: value
})
}
setinsrtRows(value) {
this.setState({
insrtRows: value
})
}
setinsertColumns(value) {
this.setState({
insertColumns: value
})
}
setdeleteRows(value) {
this.setState({
deleteRows: value
})
}
setdeleteColumn(value) {
this.setState({
deleteColumn: value
})
}
setoperateColumnOutline(value) {
this.setState({
operateColumnOutline: value
})
}
setoperateRowOutline(value) {
this.setState({
operateRowOutline: value
})
}
setProtectSheet() {
let sheet = this.spread.getActiveSheet();
if (sheet.options.isProtected) {
alert(alreadyProtect);
return ;
}
const password = this.state.password;
sheet.protect(password);
this.setState({
protectSheet: true,
password: ''
});
}
setUnprotectSheet() {
const password = this.state.password;
let sheet = this.spread.getActiveSheet();
if (sheet.hasPassword()) {
let success = sheet.unprotect(password);
if (!success) {
alert(passwordWrongTip);
return ;
}
} else {
sheet.unprotect();
}
this.setState({
protectSheet: false,
password: ''
});
}
initSpread(spread) {
this.spread = spread;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
let salesData = [
['Salesperson', 'Region'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East']
];
sheet.setArray(0, 0, salesData);
sheet.setColumnWidth(0, 120);
sheet.setColumnWidth(1, 120);
//unlocked cells
let style = new GC.Spread.Sheets.Style();
style.locked = false;
style.backColor = '#C3C3C3';
sheet.setStyle(-1, 8, style);
sheet.setStyle(-1, 9, style);
sheet.setStyle(15, -1, style);
sheet.setStyle(16, -1, style);
sheet.setStyle(8, 2, style);
//locked cells
let style2 = new GC.Spread.Sheets.Style();
style2.locked = true;
style2.backColor = '#F4F8EB';
sheet.setStyle(13, -1, style2);
sheet.setStyle(18, 8, style2);
sheet.setStyle(0, 0, style2)
sheet.setStyle(0, 1, style2);
let filter = new GC.Spread.Sheets.Filter.HideRowFilter(new GC.Spread.Sheets.Range(1, 0, 100, 2));
sheet.rowFilter(filter);
sheet.comments.add(5, 4, 'locked comment');
sheet.comments.add(22, 4, 'unlocked comment');
sheet.comments.get(5, 4).locked(true).displayMode(1);
sheet.comments.get(22, 4).locked(false).displayMode(1).lockText(false);
var _commandManager = spread.commandManager();
_commandManager.execute({
cmd: "outlineColumn",
sheetName: sheet.name(),
index: 11,
count: 3
});
_commandManager.execute({
cmd: "outlineRow",
sheetName: sheet.name(),
index: 18,
count: 3
});
spread.resumePaint();
let option = {
allowSelectLockedCells: true,
allowSelectUnlockedCells: true,
allowFilter: true,
allowSort: false,
allowResizeRows: true,
allowResizeColumns: false,
allowEditObjects: false,
allowDragInsertRows: false,
allowDragInsertColumns: false,
allowInsertRows: false,
allowInsertColumns: false,
allowDeleteRows: false,
allowDeleteColumns: false
};
sheet.options.protectionOptions = option;
sheet.options.isProtected = true;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sizedLabel {
display: inline-block;
width: 180px;
}
.colorLabel {
background-color: #F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Sometimes you don't want the values of cells in a sheet to be edited. If so, you can use the isProtected option to set and get whether the sheet is protected.
If you want to protect the worksheet with a password, you can use protect, unprotect and hasPassword API.
When a sheet is protected, you can use protectionOptions to limit user actions by providing an object with the following properties:
allowSelectLockedCells: Boolean that represents whether the user can select locked cells.
allowSelectUnlockedCells: Boolean that represents whether the user can select unlocked cells.
allowSort: Boolean that represents whether the user can sort ranges.
allowFilter: Boolean that represents whether the user can filter ranges.
allowEditObjects: Boolean that represents whether the user can edit floating objects.
allowResizeRows: Boolean that represents whether the user can resize rows.
allowResizeColumns: Boolean that represents whether the user can resize columns.
allowDragInsertRows: Boolean that represents whether the user can drag insert rows.
allowDragInsertColumns: Boolean that represents whether the user can drag insert columns.
allowInsertRows: Boolean that represents whether the user can insert rows.
allowInsertColumns: Boolean that represents whether the user can insert columns.
allowDeleteRows: Boolean that represents whether the user can delete rows.
allowDeleteColumns: Boolean that represents whether the user can delete columns.
allowOutlineRows: Boolean that represents whether the user can expand or collapse row outline.
allowOutlineColumns: Boolean that represents whether the user can expand or collapse column outline.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<br />
<div class="option-row" style="height: 25px">
<img id="protectStatus" style="height: 25px" :src="getProtectImage" />
</div>
<div class="option-row">
<label for="protectPassword">Password (optional)</label>
<input id="protectPassword" type="password" v-model="password" />
<input type="button" value="Protect" id="protectBtn" style="width:100px;" v-on:click="setProtectSheet"
:disabled="protectSheet" />
<input type="button" value="Unprotect" id="unprotectBtn" style="width:100px;" v-on:click="setUnprotectSheet"
:disabled="!protectSheet" />
</div>
<br />
<div class="option-row">
<label>Use following protection options to limit what the user can do in regards to editing the sheet.</label>
</div>
<div>
<div class="option-row">
<input id="chkSelectLockedCells" type="checkbox" v-model="selectLockedCells" />
<label for="chkSelectLockedCells" class="sizedLabel">Select locked cells</label>
</div>
<div class="option-row">
<input id="chkSelectUnlockedCells" type="checkbox" v-model="selectUnlockedCells" />
<label for="chkSelectUnlockedCells" class="sizedLabel">Select unlocked cells</label>
</div>
<div class="option-row">
<input id="chkAllowSort" type="checkbox" v-model="sort" />
<label for="chkAllowSort" class="sizedLabel">Sort</label>
</div>
<div class="option-row">
<input id="chkAllowFilter" type="checkbox" v-model="filter" />
<label for="chkAllowFilter" class="sizedLabel">Filter</label>
</div>
<div class="option-row">
<input id="chkAllowResizeRows" type="checkbox" v-model="resizeRows" />
<label for="chkAllowResizeRows" class="sizedLabel">Resize rows</label>
</div>
<div class="option-row">
<input id="chkAllowResizeColumns" type="checkbox" v-model="resizeColums" />
<label for="chkAllowResizeColumns" class="sizedLabel">Resize columns</label>
</div>
<div class="option-row">
<input id="chkAllowEditObjects" type="checkbox" v-model="editObject" />
<label for="chkAllowEditObjects" class="sizedLabel">Edit objects</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertRows" type="checkbox" v-model="dragInsertRows" />
<label for="chkAllowDragInsertRows" class="sizedLabel">Drag insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowDragInsertColumns" type="checkbox" v-model="dragInsertColums" />
<label for="chkAllowDragInsertColumns" class="sizedLabel">Drag insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowInsertRows" type="checkbox" v-model="insrtRows" />
<label for="chkAllowInsertRows" class="sizedLabel">Insert rows</label>
</div>
<div class="option-row">
<input id="chkAllowInsertColumns" type="checkbox" v-model="insertColumns" />
<label for="chkAllowInsertColumns" class="sizedLabel">Insert columns</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteRows" type="checkbox" v-model="deleteRows" />
<label for="chkAllowDeleteRows" class="sizedLabel">Delete rows</label>
</div>
<div class="option-row">
<input id="chkAllowDeleteColumns" type="checkbox" v-model="deleteColumn" />
<label for="chkAllowDeleteColumns" class="sizedLabel">Delete columns</label>
</div>
<div class="option-row">
<input id="chkallowOutlineRows" type="checkbox" v-model="operateRowOutline" />
<label for="chkallowOutlineRows" class="sizedLabel">Operate row outline</label>
</div>
<div class="option-row">
<input id="chkallowOutlineColumns" type="checkbox" v-model="operateColumnOutline" />
<label for="chkallowOutlineColumns" class="sizedLabel">Operate column outline</label>
</div>
<div class="option-row">
<input type="button" value="Set" id="setProtectionOptions" v-on:click="applySetting" style="width: 100px " />
</div>
<div class="option-row">
<label>Select the protection options and then click Set</label>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from '@mescius/spread-sheets';
import { ref, watch, computed } from "vue";
import "@mescius/spread-sheets-vue";
const passwordWrongTip = 'Password is not correct!';
const alreadyProtect = 'The worksheet is already protected!';
const unprotectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB0UlEQVR4nO2YzU7CQBDHNyae9A30qF6NNlFv7QzhqheukN1An4Mbnv14A70YwgERX0XiWRNBKl8eMDGuGWy0LopoS0tl/8kkZLMT/r+dmW1axrS0tAKTYRjziJgCgFNEvAKAR0Tsub9pLUV72DTKsqw9ALhGRDkqaA/tZdOifD4/h4j7PxlX4gURC5QbtX/2B/PeKERqnlrBPU1vi/QR8dCyrO1kMrlAYZrmDgAcAcCTWgkA2I3EPA2j2vMAcAMA69/lJBKJDQC4VWfCiGKw6UZRT36UeU/e5heVSLGw5V6LXhMHv8g9VuBPWNhCxJoCsDVuLs2EkltjYct9QL2bME1zcdxc2qsA9FjYUq/EsPN9SwOgrsD4yuVyy5zzIue8K4SQkwz+9h8lzvlqkOadSRsXwyBOJpNZ8g1AJx+2efEBcRYEQDdCgLZvgKjMCzc0gNAVELqFfGkmW8i2bXl5cS7bTkO2mnVZrZQHa7EBqFbKUj73PwWtxQag7TSGAGgtNgCtZn0I4OH+Lj4A1bi3kG3bA8NUiVgOsQgwmAYQugJSt9Cst1An7q+UpQgBir4B0un0mhCiGYF5J5vNrrAgRN9n6BNHSO3UoZMPzLyW1j/XK1zJDTLJ864hAAAAAElFTkSuQmCC';
const protectImg = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAACXBIWXMAAAsTAAALEwEAmpwYAAAB10lEQVR4nO2Yz0rDQBDGB0Ev+gZ6VK+iAfWWzJRe9dL3qfVQlWwR/7yBXqT0JepD2Nar0h4s2ERq3YArW4LGrdZq0qSx+8FACDvw/XZmNmQBtLS0IpNhGLNElEPESyK6QcQnInL9Z/kuJ9fAJMqyrF1EbBCRGBZyjVwLk6J8Pj9DRAc/GVfilYiKMjdp//AH88EoJmpetoK/m8EW6RHRqWVZW9lsdl6GaZrbiHiGiC9qJRBxJxHzchjVnkfEO0Rc+y4nk8msI+K9OhNGEoMtTxR154eZD+RtfFGJHMQt/1gMmjj5Re65An8BcYuIagrA5qi5ciaU3BrELf8D9W7CNM2FUXPlWgXAhbilHolx54eWBiBdgdElDmGJMyhzBo7HQIwzOAOHM6j0jmAlOvM2tMdt3FNBbGiLEiyGBpA7H7d576MaV1EAOAkCPIYGSMq854cG8HQFQLdQKE1nCx3Pie71vnBbDeE266JbLfTfpQagWy0Ix3E+RR8iLQBuqzEA4LZuUwTQrA8CNGtpb6G9lA1xtdCvRCqH2IswQAMwXQGhW2iqW4jb0En1LyVnUEkQoBwaoMdglTN4iN28De3nEixDFJL3M/KKI4524jZ05M5HZl5L65/rDc6nQtkkwmMVAAAAAElFTkSuQmCC';
let spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
const spreadRef = ref(null);
const protectSheet = ref(true);
const selectLockedCells = ref(true);
const selectUnlockedCells = ref(true);
const sort = ref(false);
const filter = ref(true);
const resizeRows = ref(true);
const resizeColums = ref(false);
const editObject = ref(false);
const dragInsertRows = ref(false);
const dragInsertColums = ref(false);
const insrtRows = ref(false);
const insertColumns = ref(false);
const deleteRows = ref(false);
const deleteColumn = ref(false);
const operateColumnOutline = ref(false);
const operateRowOutline = ref(false);
const password = ref('');
let getProtectImage = computed(() => {
return protectSheet.value ? protectImg : unprotectImg;
});
let initSpread = function (spread) {
spreadRef.value = spread;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
let salesData = [
['Salesperson', 'Region'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East'],
['Erich', 'West'],
['Dafna', 'North'],
['Rob', 'South'],
['Joe', 'North'],
['Robert', 'South'],
['Michelle', 'East']
];
sheet.setArray(0, 0, salesData);
sheet.setColumnWidth(0, 120);
sheet.setColumnWidth(1, 120);
//unlocked cells
let style = new GC.Spread.Sheets.Style();
style.locked = false;
style.backColor = '#C3C3C3';
sheet.setStyle(-1, 8, style);
sheet.setStyle(-1, 9, style);
sheet.setStyle(15, -1, style);
sheet.setStyle(16, -1, style);
sheet.setStyle(8, 2, style);
//locked cells
let style2 = new GC.Spread.Sheets.Style();
style2.locked = true;
style2.backColor = '#F4F8EB';
sheet.setStyle(13, -1, style2);
sheet.setStyle(18, 8, style2);
sheet.setStyle(0, 0, style2)
sheet.setStyle(0, 1, style2);
let filter = new GC.Spread.Sheets.Filter.HideRowFilter(new GC.Spread.Sheets.Range(1, 0, 100, 2));
sheet.rowFilter(filter);
sheet.comments.add(5, 4, 'locked comment');
sheet.comments.add(22, 4, 'unlocked comment');
sheet.comments.get(5, 4).locked(true).displayMode(1);
sheet.comments.get(22, 4).locked(false).displayMode(1).lockText(false);
var _commandManager = spread.commandManager();
_commandManager.execute({
cmd: "outlineColumn",
sheetName: sheet.name(),
index: 11,
count: 3
});
_commandManager.execute({
cmd: "outlineRow",
sheetName: sheet.name(),
index: 18,
count: 3
});
spread.resumePaint();
let option = {
allowSelectLockedCells: true,
allowSelectUnlockedCells: true,
allowFilter: true,
allowSort: false,
allowResizeRows: true,
allowResizeColumns: false,
allowEditObjects: false,
allowDragInsertRows: false,
allowDragInsertColumns: false,
allowInsertRows: false,
allowInsertColumns: false,
allowDeleteRows: false,
allowDeleteColumns: false
};
sheet.options.protectionOptions = option;
sheet.options.isProtected = true;
}
function applySetting() {
let option = {
allowSelectLockedCells: selectLockedCells.value,
allowSelectUnlockedCells: selectUnlockedCells.value,
allowSort: sort.value,
allowFilter: filter.value,
allowResizeRows: resizeRows.value,
allowResizeColumns: resizeColums.value,
allowEditObjects: editObject.value,
allowDragInsertRows: dragInsertRows.value,
allowDragInsertColumns: dragInsertColums.value,
allowInsertRows: insrtRows.value,
allowInsertColumns: insertColumns.value,
allowDeleteRows: deleteRows.value,
allowDeleteColumns: deleteColumn.value,
allowOutlineColumns: operateColumnOutline.value,
allowOutlineRows: operateRowOutline.value
};
let sheet = spreadRef.value.getActiveSheet();
sheet.options.protectionOptions = option;
}
function setProtectSheet(value) {
let sheet = spreadRef.value.getActiveSheet();
if (sheet.options.isProtected) {
alert(alreadyProtect);
return;
}
const passwordValue = password.value;
password.value = '';
sheet.protect(passwordValue);
protectSheet.value = sheet.options.isProtected;
}
function setUnprotectSheet() {
const passwordValue = password.value;
let sheet = spreadRef.value.getActiveSheet();
if (sheet.hasPassword()) {
let success = sheet.unprotect(passwordValue);
if (!success) {
alert(passwordWrongTip);
return;
}
} else {
sheet.unprotect();
}
password.value = '';
protectSheet.value = sheet.options.isProtected;
}
</script>
<style scoped>
#app {
height: 100%;
}
.sizedLabel {
display: inline-block;
width: 180px;
}
.colorLabel {
background-color: #F4F8EB;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);